/*
  Reverse Accepts Lights
    (C) あかつきみさき(みくちぃP)

  このスクリプトについて
    選択したレイヤーに「ライトを受ける」プロパティが存在する場合に値を反転するスクリプト.

  使用方法
    レイヤーを選択してからスクリプトを実行してください.

  動作環境
    Adobe After Effects CS5以上

  バージョン情報
    2015/12/10 Ver 1.0.0 Release
*/

/// <reference path="C:/lib/ae.d.ts"/>

(function() {
	const ADBE_MATERIAL_OPTIONS_GROUP = "ADBE Material Options Group";
	const ADBE_ACCEPTS_LIGHTS = "ADBE Accepts Lights"
	
  const isCompActive = function(comp:CompItem) {
    if (!(comp && comp instanceof CompItem)) {
      return false;
    } else {
      return true;
    }
  }

  const isLayerSelected = function(layers:Layer[]) {
    if (layers.length === 0) {
      return false;
    } else {
      return true;
    }
  }

	const actComp:CompItem = <CompItem>app.project.activeItem;
    
  if (!isCompActive(actComp)) {
    return 0;
  }

	const selLayers:Layer[] = <Layer[]>actComp.selectedLayers;
  if (!isLayerSelected(selLayers)) {
    return 0;
  }
	
	app.beginUndoGroup("Reverse Accepts Lights");
	
	let curProperty:Property;
	for (let i=0; i<selLayers.length; i++){
		if(selLayers[i].property(ADBE_MATERIAL_OPTIONS_GROUP) == null){
			continue;
		}
		curProperty = selLayers[i].property(ADBE_MATERIAL_OPTIONS_GROUP).property(ADBE_ACCEPTS_LIGHTS);
		if(curProperty !== null){
			curProperty.setValue(!curProperty.value);
		}
	} 

	app.endUndoGroup();

}).call(this);
